--[[
		SuperGuildInvite by Janniie - Stormreaver EU
		
		~~Special thanks to~~   
			Minayuki - Argent Dawn EU
			
			
		

]]
local ID = "SG_INV"
local ID2 = "SGI_REQ"
local ID3 = "SGI_BLACK"
local version = "4.3"
local version_min = ""
local Frames = {}
local inBattleground = false
local inDungeon = false
local DungeonFinnished = false
local WhoTime = GetTime() + 10
local ScanZone,AllZones = 1,{}
local TimerTime = 0
local progressBar = 0
local TimeLeft = 0
local cooldown = false
local AmountPlayers = 0
local SessionTotal = 0
local AmountGuildLess = 0
local AmountQueued = 0
local Logo = "|cffffff00<|r|cff16ABB5SGI|r|cffffff00>|r "
local ActiveWindows = {}
local InviteFrames = {}
local Highlights = {}
local Tooltips = {}

local GetTime = GetTime
local strfind = strfind
local strsub = strsub
local tonumber = tonumber


-- A fix for 4.3 where GuildInvite() will have a 1sec cooldown --
local InviteQueue = {}
local DetailedQueue = {}
local InviteDelay = 0
local WhoDelay = 7
local LastInvite = 0
local WaitForWho = false

Funcs = {}

-- NOTES TO SELF--
--
-- TO DO 3.0:
-- >> Search all server								NOT DOABLE
-- >> Custom Whisper -- 							DONE
-- >> Finnish the new UI --							MOSTLY DONE
-- >> Invite Whisper Requests  --					DONE, Untested
-- >> Cross-Realm Areas and BG's, Dungeons DISABLE	DONE
-- >> Manual Searches -- 							DONE
-- >> Black list 									DONE
-- >> Off By Default --								DONE

-- TO DO FOR 3.1:
-- >> Systematic Scans								DONE
-- >> Fix ESC button								DONE
-- >> Synchronize within the guild					DONE

local function Add_To_Blacklist(name,mode)
	BlackList[name] = mode
	SendAddonMessage(ID3,"","GUILD")
	print(Logo.."|cffff0000"..name.."|r"..SGI_ADDED_TO_BLACKLIST)
end	

local function Remove_From_Blacklist(name)
	BlackList[name] = nil
	print(Logo.."|cffff0000"..name.."|r"..SGI_REMOVED_FROM_BLACKLIST)
end


local function QueueInvite(name)
	tinsert(InviteQueue,name)
	if Frames["OptBtn10"] then
		Frames["OptBtn10"]:SetText(SGI_INVITE..": "..(#InviteQueue or ""))
	end
end

local function CountTable(T)
	local i = 0
	if not T then return 0 end
	for k,_ in pairs(T) do
		i = i + 1
	end
	return i
end

local function Whisper_AddName(msg,name)
	local whisper
	if strfind(msg,"PLAYER") then
		whisper = strsub(msg,1,strfind(msg,"PLAYER")-1)..name..strsub(msg,strfind(msg,"PLAYER")+6)
	else
		whisper = msg
	end
	return whisper
end

local function getClassColor(class)
	if class == "DEATHKNIGHT" then
		return "C41F3B" 
	elseif class == "DRUID" then
		return "FF7D0A"
	elseif class == "HUNTER" then
		return "ABD473"
	elseif class == "MAGE" then
		return "69CCF0"
	elseif class == "PALADIN" then
		return "F58CBA"
	elseif class == "PRIEST" then
		return "FFFFFF"
	elseif class == "ROGUE" then
		return "FFF569"
	elseif class == "SHAMAN" then
		return "0070DE"
	elseif class == "WARLOCK" then
		return "9482C9"
	elseif class == "WARRIOR" then
		return "C79C6E"
	else
		return "857C7C"
	end
end

local function SpecialRemove1(T,N)
	local OUT = {}
	for k,_ in pairs(T) do
		if T[k] ~= N then
			OUT[k] = T[k]
		end
	end
	return OUT
end

local function SpecialRemove2(T,N)
	local OUT = {}
	for k,_ in pairs(T) do
		if k ~= N then
			OUT[k] = T[k]
		end
	end
	return OUT
end

local function Manual_ListInvite(name)
	GuildInvite(name)
	if SuperGuildInviteOptions["OptBtn2"] then
		local Whisper = Whisper_AddName(SuperGuildInviteOptions.Whisper,name)
		SendChatMessage(Whisper,"WHISPER",nil,name)
	end
	ChatFrame1:AddMessage(Logo..SGI_TRIED_TO_INVITE1..name..SGI_TRIED_TO_INVITE2,0.28,0.46,1,1)
	InviteQueue = SpecialRemove1(InviteQueue,name)
	DetailedQueue = SpecialRemove2(DetailedQueue,name)
	if Frames["OptBtn10"] then
		Frames["OptBtn10"]:SetText("INVITE: "..(#InviteQueue or ""))
	end
end

local function ListNamesToInvite()
	if not (InviteListFrame and InviteListFrame:IsShown())then return end
	local Loc_Queue,i = DetailedQueue,0
	local X,Y = 10, -30
	sort(Loc_Queue,function(a,b) return a["InviteTime"] < b["InviteTime"] end)
	
	for k,_ in pairs(InviteFrames) do
		InviteFrames[k]:Hide()
	end
	InviteFrames = {}
	Highlights = {}
	Tooltips = {}
	local Names = {}
	
	InviteListFrame:SetHeight(20*CountTable(DetailedQueue)+ 40) 
	
	for k,_ in pairs(Loc_Queue) do
		i = i + 1
		local Lvl,ClassF,Race,Class = Loc_Queue[k]["level"],Loc_Queue[k]["classF"],Loc_Queue[k]["race"],Loc_Queue[k]["class"]
		local Text = i..". |cff"..getClassColor(ClassF)..k.."|r Lvl "..Lvl.." "..Race.." |cff"..getClassColor(ClassF)..Class.."|r"
		Names[i] = k
		InviteFrames[i] = CreateFrame("Button","SuperGuildInviteFrame"..i)
		InviteFrames[i]:SetWidth(290)
		InviteFrames[i]:SetHeight(20)
		InviteFrames[i]:SetPoint("TOPLEFT",InviteListFrame,"TOPLEFT",X,Y)
		Y = Y - 20
		InviteFrames[i]:Show()
		InviteFrames[i]:SetFrameStrata("HIGH")
		InviteFrames[i]:SetScript("OnClick",function(self)
			Manual_ListInvite(k)
			ListNamesToInvite()
		end)
		
		local Font = InviteFrames[i]:CreateFontString("SuperGuildInviteFrameFont"..i,"OVERLAY","GameFontNormal")
		Font:SetText(Text)
		Font:SetPoint("LEFT",InviteFrames[i],"LEFT",3,0)
		Font:SetJustifyH("LEFT")
		
		Highlights[i] = InviteFrames[i]:CreateTexture()
		Highlights[i]:SetPoint("CENTER",InviteFrames[i],"CENTER",-5,0)
		Highlights[i]:SetWidth(280)
		Highlights[i]:SetHeight(17)
		Highlights[i]:SetTexture(1,1,0,0.2)
		Highlights[i]:Hide()
		
		InviteFrames[i]:SetScript("OnEnter",function()
			Highlights[i]:Show()
		end)
		InviteFrames[i]:SetScript("OnLeave",function()
			Highlights[i]:Hide()
		end)
	end
	for j = 1,i do
		Highlights[j] = InviteFrames[j]:CreateTexture()
		Highlights[j]:SetPoint("CENTER",InviteFrames[j],"CENTER",-5,0)
		Highlights[j]:SetWidth(280)
		Highlights[j]:SetHeight(17)
		Highlights[j]:SetTexture(1,1,0,0.2)
		Highlights[j]:Hide()
		
		Tooltips[j] = CreateFrame("Frame","ToolTip_SGI"..j,InviteFrames[j],"GameTooltipTemplate")
		Tooltips[j]:SetPoint("RIGHT",InviteFrames[j],"LEFT",-5,0)
		Tooltips[j]:SetWidth(200)
		Tooltips[j]:SetHeight(50)
		local font = Tooltips[j]:CreateFontString(nil,"OVERLAY","GameFontNormal")
		font:SetPoint("LEFT",Tooltips[j],"LEFT",10,0)
		font:SetText("Queued: "..Loc_Queue[Names[j]]["InviteTime"])
		font:SetWidth(190)
		font:SetJustifyH("LEFT")
		
		InviteFrames[j]:SetScript("OnEnter",function()
			Highlights[j]:Show()
			Tooltips[j]:Show()
		end)
		InviteFrames[j]:SetScript("OnLeave",function()
			Highlights[j]:Hide()
			Tooltips[j]:Hide()
		end)
		
	end
end

local function SetSavedFramePos(Frame)
	if not Frame then print(Logo.."Error: No frame") end
	
	local name = Frame:GetName()

	SuperGuildInviteOptions[name.."Xpos"] = SuperGuildInviteOptions[name.."Xpos"] or 0
	SuperGuildInviteOptions[name.."Ypos"] = SuperGuildInviteOptions[name.."Ypos"] or 0
	SuperGuildInviteOptions[name.."P1"] = SuperGuildInviteOptions[name.."P1"] or "CENTER"
	SuperGuildInviteOptions[name.."P2"] = SuperGuildInviteOptions[name.."P2"] or "CENTER"

	
	Frame:SetPoint(SuperGuildInviteOptions[name.."P1"],UIParent,SuperGuildInviteOptions[name.."P2"],SuperGuildInviteOptions[name.."Xpos"],SuperGuildInviteOptions[name.."Ypos"])
end

local function SaveCurFramePos(Frame)
	if not Frame then print(Logo.."Error: No frame") end
	
	local name = Frame:GetName()

	local point, relativeTo, relativePoint, xOfs, yOfs = Frame:GetPoint()

	SuperGuildInviteOptions[name.."Xpos"] = xOfs
	SuperGuildInviteOptions[name.."Ypos"] = yOfs
	SuperGuildInviteOptions[name.."P1"] = point
	SuperGuildInviteOptions[name.."P2"] = relativePoint
end

local function Manual_Invite()
	if #InviteQueue == 0 then
		print(Logo..SGI_EMPTY_QUEUE)
	else
		for k,_ in pairs(InviteQueue) do
			GuildInvite(InviteQueue[k])
			if SuperGuildInviteOptions["OptBtn2"] then
				local Whisper = Whisper_AddName(SuperGuildInviteOptions.Whisper,InviteQueue[k])
				SendChatMessage(Whisper,"WHISPER",nil,InviteQueue[k])
			end
			ChatFrame1:AddMessage(Logo..SGI_TRIED_TO_INVITE1..InviteQueue[k]..SGI_TRIED_TO_INVITE2,0.28,0.46,1,1)
			DetailedQueue = SpecialRemove2(DetailedQueue,InviteQueue[k])
			tremove(InviteQueue,k)
			if Frames["OptBtn10"] then
				Frames["OptBtn10"]:SetText("INVITE: "..(#InviteQueue or ""))
			end
			break
		end
		print(Logo.."|cff00ff00"..#InviteQueue.."|r"..SGI_PLAYERS_LEFT)
		ListNamesToInvite()
	end
end




local function GetActiveWindows()
	ActiveWindows = {}
	if WorldMapFrame and WorldMapFrame:IsShown() then
		ActiveWindows["WorldMapFrame"] = WorldMapFrame
	end
	if CharacterFrame and CharacterFrame:IsShown() then
		ActiveWindows["Character"] = CharacterFrame
	end
	if SpellBookFrame and SpellBookFrame:IsShown() then
		ActiveWindows["SpellBook"] = SpellBookFrame
	end
	if EncounterJournal and EncounterJournal:IsShown() then
		ActiveWindows["Encounter"] = EncounterJournal
	end
	if PlayerTalentFrame and PlayerTalentFrame:IsShown() then
		ActiveWindows["Talent"] = PlayerTalentFrame
	end
	if AchievementFrame and AchievementFrame:IsShown() then
		ActiveWindows["Achievement"] = AchievementFrame
	end
	
end

local function RestoreActiveWindows()
	for k,_ in pairs(ActiveWindows) do
		ActiveWindows[k]:Show()
	end
	ActiveWindows = {}
end

local function SuperScan()
	if SuperGuildInviteOptions["OptBtn1"] and SuperGuildInviteOptions["OptBtn9"] and GetTime() - WhoTime > WhoDelay then
		local i = 0
		for k,_ in pairs(AllZones) do
			i = i + 1
			local zone = AllZones[k]
			if ScanZone == i then
				GetActiveWindows()
				TimeLeft = (#AllZones-ScanZone+1) * WhoDelay
				SetWhoToUI(1)
				SendWho(zone)
				SuperGuildInviteGeneral.DoInvites = true
				cooldown = false
				break
			elseif i == #AllZones then
				ScanZone = 1
				SessionTotal = SessionTotal + AmountPlayers
				print(Logo..SGI_SCAN_COMPLETE)
				print(Logo..SGI_PLAYERS_SCANNED.."|cff44FF44"..AmountPlayers.." |r|cffffff00(Total: "..SessionTotal..")|r")
				print(Logo..SGI_GUILDLESS_PLAYERS.."|cff44FF44"..AmountGuildLess.."|r|cffffff00 "..(floor(1000*AmountGuildLess/AmountPlayers)/10).."%|r")
				print(Logo..SGI_INVITES_QUEUED.."|cff44FF44"..AmountQueued.."|r")
				AmountPlayers = 0
				AmountGuildLess = 0
				AmountQueued = 0
				WhoTime = GetTime() + 5
				TimeLeft = 15
				cooldown = true
				return
			end
		end
		WhoTime = GetTime()
	end
end
local ff = CreateFrame("Frame")
ff:SetScript("OnUpdate",SuperScan)



local function DisplayBlacklist()
	print(Logo.."|cff88ffffCurrently Blacklisted players:|r")
	for k,_ in pairs(BlackList) do
		if BlackList[k] == "AUTOMATIC" then
			print(Logo.."|cff33ff33"..k.."|r|cff88ffff was added automatically.|r")
		else
			print(Logo.."|cff33ff33"..k.."|r|cff88ffff was added manually.|r")
		end
	end
end

local function Create_Search(Low,high)
	local Levels,i = {}
	high = high or 85
	if not Low then
		Levels = {"-5"}
		i = 5
	elseif mod(Low,5) ~= 0 then
		tinsert(Levels,Low.."- -"..Low+(5-mod(Low,5)))
		i = Low+(5-mod(Low,5))
	else
		i = Low
	end
	
	while i<high and i<80 do
		tinsert(Levels,i.."- -"..(i+4))
		i = i + 5
	end
	if high == 81 then
		tinsert(Levels,"81")
	elseif high == 82 then
		tinsert(Levels,"80- -82")
	elseif high == 83 then
		tinsert(Levels,"80- -82")
		tinsert(Levels,"83")
	elseif high == 84 then
		tinsert(Levels,"80- -82")
		tinsert(Levels,"83- -84")
	elseif high == 85 then
		tinsert(Levels,"80- -82")
		tinsert(Levels,"83- -84")
		local Classes = {
			"Death Knight",
			"Priest",
			"Druid",
			"Mage",
			"Warrior",
			"Warlock",
			"Paladin",
			"Rogue",
			"Shaman",
			"Hunter",
		}
		for k,_ in pairs(Classes) do
			tinsert(Levels,"85 c-"..Classes[k])
		end
	end
	AllZones = Levels	
	ScanZone = 1
end




--Registered Events--

local function ZoneChanged()
	local WhoReqZone = GetRealZoneText()
	if IsInGuild() and CanGuildInvite() and SuperGuildInviteOptions["OptBtn1"] then
		SetWhoToUI(1)
		SendWho("z-"..WhoReqZone.."")
		SuperGuildInviteGeneral.DoInvites = true
	elseif not IsInGuild() and SuperGuildInviteOptions["OptBtn1"] then
		SuperGuildInviteOptions["OptBtn1"] = false
		print(Logo..SGI_NOT_IN_GUILD)
		print(Logo..SGI_TURNED_OFF)
	elseif not IsInGuild() and not CanGuildInvite() and SuperGuildInviteOptions["OptBtn1"] then
		SuperGuildInviteOptions["OptBtn1"] = false
		print(Logo..SGI_CANT_INVITE)
		print(Logo..SGI_TURNED_OFF)
	end
end

local function WhoList()
	if SuperGuildInviteOptions["OptBtn1"] and SuperGuildInviteGeneral.DoInvites then
		SuperGuildInviteGeneral.DoInvites = false
		if SuperGuildInviteOptions["OptBtn9"] then
			ScanZone = ScanZone + 1
		end
		for i = 1,GetNumWhoResults() do
			AmountPlayers = AmountPlayers + 1
			local name, guild, level, race, class, zone, classFileName= GetWhoInfo(i)
			if guild == "" then 
				AmountGuildLess = AmountGuildLess + 1
				InviteTime = tonumber(date("%j"))
				if SuperGuildInviteOptions["OptBtn4"] == 1 then
					extra = 0
				elseif SuperGuildInviteOptions["OptBtn4"] == 2 then
					extra = 1
				else
					extra = 7
				end
				if (not SuperGuildInviteGeneral["DATES"][name] or InviteTime > (extra + SuperGuildInviteGeneral["DATES"][name])) then
					if not BlackList[name] then
						SuperGuildInviteGeneral["DATES"][name] = InviteTime
						SuperGuildInviteGeneral["TRIES"]["tries "..name] = (SuperGuildInviteGeneral["TRIES"]["tries "..name] or 0) + 1
						if SuperGuildInviteGeneral["TRIES"]["tries "..name] > (SuperGuildInviteOptions.tries or 100) then
							Add_To_Blacklist(name,"AUTOMATIC")
						else
							QueueInvite(name)
							DetailedQueue[name] = {
								["level"] = level,
								["classF"] = classFileName,
								["race"] = race,
								["class"] = class,
								["InviteTime"] = date(),
							}
							AmountQueued = AmountQueued + 1
							ChatFrame1:AddMessage(Logo..name..SGI_PLAYER_NOT_IN_GUILD,1,0.2,0.2,1)
						end
					else
						print(Logo.."|cffff0000"..name.."|r"..SGI_IS_BLACKLISTED)
					end
				end
			end
		end
		ListNamesToInvite()
		if SuperGuildInviteOptions["OptBtn3"] then
			FriendsFrameCloseButton:Click()
			RestoreActiveWindows()
		end
		if SuperGuildInviteOptions["OptBtn5"] then
			Frames["OptBtn5"]:SetTextColor(1,0,0)
		end
		WaitForWho = true
	end
end

local function LoginPlayer()
	if type(SuperGuildInviteGeneral) ~= "table" or tonumber(date("%j")) < (SuperGuildInviteGeneral[UnitName("Player")] or 0) then --New user or new year
		SuperGuildInviteGeneral = {}
		SuperGuildInviteGeneral["DATES"] = {}
		SuperGuildInviteGeneral["TRIES"] = {}
		SuperGuildInviteGeneral[UnitName("Player")] = tonumber(date("%j"))
	end
	if type(SuperGuildInviteGeneral["DATES"]) ~= "table" then
		SuperGuildInviteGeneral["DATES"] = {}
	end
	if type(SuperGuildInviteGeneral["TRIES"]) ~= "table" then
		SuperGuildInviteGeneral["TRIES"] = {}
	end
	if type(SuperGuildInviteOptions) ~= "table" then
		SuperGuildInviteOptions = {}
		SuperGuildInviteOptions["OptBtn1"] = false
		
		SuperGuildInviteOptions.Whisper = "Would you like to join my guild? The please press Accept!"
	end
	if type(BlackList) ~= "table" then
		BlackList = {}
	end
	print(Logo..SGI_HELP)
	if SuperGuildInviteOptions["OptBtn1"] then
		ChatFrame1:AddMessage(Logo..SGI_TURNED_ON,0,1,0,1)
	else
		ChatFrame1:AddMessage(Logo..SGI_TURNED_OFF,1,0,0,1)
	end
	SendAddonMessage(ID,version,"GUILD")
	SendAddonMessage(ID2,"","GUILD")
	SuperGuildInviteOptions.OptionsFrame = nil
	SuperGuildInviteOptions.Search = nil
	SuperGuildInviteOptions["OptBtn5"] = nil
	SuperGuildInviteOptions["OptBtn9"] = nil
	cooldown = true
	
	InviteDelay = 1.1
	WhoDelay = 7 
	
	
	Create_Search(SuperGuildInviteOptions.LowLimit,SuperGuildInviteOptions.HighLimit)

	for k,_ in pairs(SuperGuildInviteGeneral["DATES"]) do
		if SuperGuildInviteGeneral["DATES"][k] + 8 < tonumber(date("%j")) then
			SuperGuildInviteGeneral["DATES"][k] = nil
		end
	end
	
	SetSavedFramePos(SGIMiniMapButton)
	
end

local function AddOnMsg(prefix,msg,sender)
	if prefix == ID then
		if tonumber(version)<(tonumber(msg) or 0) then
			ChatFrame1:AddMessage(Logo..SGI_NEW_VERSION_AVAILABLE1..msg..SGI_NEW_VERSION_AVAILABLE2,0.5,1,1,1)
		end
	elseif prefix == ID2 and sender ~= UnitName("player") then
		for k,_ in pairs(BlackList) do
			SendAddonMessage(ID3,"NAME:"..k.."MODE:"..BlackList[k],"GUILD")
		end
	elseif prefix == ID3 and sender ~= UnitName("player") then
		local name = strsub(msg,6,strfind(msg,"MODE:")-1)
		local mode = strsub(msg,strfind(msg,"MODE:")+5)
		Add_To_Blacklist(name,mode)
	end
end


local function OnWhisper(msg,sender)
	if IsInGuild() then
		local gName = GetGuildInfo(UnitName("Player"))
		msg = strlower(msg)
		if (sender ~= UnitName("Player")) and CanGuildInvite() and SuperGuildInviteOptions["OptBtn8"] then
			if (strfind(msg,"join") or strfind(msg,"inv")) and (strfind(msg,"guild") or strfind(msg,gName)) then
				SetWhoToUI(1)
				SendWho(sender)
				SuperGuildInviteGeneral.DoInvites = true
				print(Logo.."|cff88ffff"..sender.."|r"..SGI_WANTS_INVITE)
			end
		end
	end
end


local function OnBattleground()
	if SuperGuildInviteOptions["OptBtn1"] then
		inBattleground = true
		SuperGuildInviteOptions["OptBtn1"] = false
		print(Logo..SGI_CROSS_REALM_ENTER)
		print(Logo..SGI_TURNED_OFF)
	end
end

local function OnBGExit()
	if inBattleground then
		inBattleground = false
		SuperGuildInviteOptions["OptBtn1"] = true
		print(Logo..SGI_CROSS_REALM_EXIT)
		print(Logo..SGI_TURNED_ON)
	elseif inDungeon and DungeonFinnished then
		SuperGuildInviteOptions["OptBtn1"] = true
		print(Logo..SGI_CROSS_REALM_EXIT)
		print(Logo..SGI_TURNED_ON)
		inDungeon = false
	end
end
	

local function OnLFDgroup()
	if SuperGuildInviteOptions["OptBtn1"] then
		inDungeon = true
		SuperGuildInviteOptions["OptBtn1"] = false
		print(Logo..SGI_CROSS_REALM_ENTER)
		print(Logo..SGI_TURNED_OFF)
	end
end

local function LFD_finnished()
	if inDungeon then
		inDungeon = false
		SuperGuildInviteOptions["OptBtn1"] = true
		print(Logo..SGI_CROSS_REALM_EXIT)
		print(Logo..SGI_TURNED_ON)
	end
end

local function OnSystemMsg(msg) 
	if msg == SGI_LEAVE_GROUP or msg == SGI_REMOVED_GROUP and inDungeon then
		DungeonFinnished = true
	end
end

local function DungeonReward()
	if inDungeon then
		DungeonFinnished = true
	end
end
	
local function OnRegisteredEvent(self,event,...)
	--[[if event == "ZONE_CHANGED_NEW_AREA" then
		ZoneChanged()else]]
	if event == "WHO_LIST_UPDATE" then
		WhoList()
	elseif event == "PLAYER_LOGIN" then
		LoginPlayer()
	elseif event == "CHAT_MSG_ADDON" then
		local prefix,msg,channel,sender = select(1,...)
		AddOnMsg(prefix,msg,sender)
	elseif event == "CHAT_MSG_WHISPER" then
		local msg,sndr = select(1,...)
		OnWhisper(msg,sndr)
	elseif event == "CHAT_MSG_SYSTEM" then
		local msg = select(1,...)
		OnSystemMsg(msg)
	elseif event == "PLAYER_ENTERING_BATTLEGROUND" then
		OnBattleground()
	elseif event == "PLAYER_ENTERING_WORLD" then
		OnBGExit()
	elseif event == "LFG_PROPOSAL_SUCCEEDED" then
		OnLFDgroup()
	elseif event == "LFG_COMPLETION_REWARD" then
		DungeonReward()
	end
end






-- Frames --



local function CreateButton(name,parent)
	local frame = CreateFrame("Button",name,parent,"UIPanelButtonTemplate")
	frame:SetWidth(60)
	frame:SetHeight(20)
	frame:SetPoint("CENTER")
	
	local font = frame:CreateFontString(nil,"OVERLAY","GameFontNormal")
	font:SetText("")
	font:SetPoint("CENTER")
	return frame
end

local function Modify_Button(Button,text,Height,Width,Color,Anchor,FUNCTION,FUNCTION2)
	if not Button then print(Logo.."error in (function) Modify_Button") return end
	if text then
		local font = Button:GetFontString()
		font:SetText(text)
	end
	if Height or Width then
		if Height then
			Button:SetHeight(Height)
		end
		if Width then
			Button:SetWidth(Width)
		end
	end
	if type(Color) == "table" then
		local font = Button:GetFontString()
		font:SetTextColor(Color.Red,Color.Green,Color.Blue)
	end
	if type(Anchor) == "table" then
		Button:SetPoint(Anchor.Point,Anchor.RelativeFrame,Anchor.RelativePoint,Anchor.xOfs,Anchor.yOfs)
	end
	if FUNCTION then
		Button:SetScript("OnClick",FUNCTION)
	end
	if FUNCTION2 then
		Button:SetScript("OnEnter",FUNCTION2)
		Button:SetScript("OnLeave",FUNCTION2)
	end
end



local function Checkbox_OnClick(self)
	local Enabled = self:GetChecked()
	if Enabled == 1 then
		Settings["CheckBox: "..self:GetName()] = true
	else
		Settings["CheckBox: "..self:GetName()] = false
	end
	BlizzardOptionsPanel_CheckButton_OnClick(self)
end

local function Checkbox_OnEnter(self)
	local child = self:GetChildren()
	child:Show()
end

local function Checkbox_OnLeave(self)
	local child = self:GetChildren()
	child:Hide()
end

local function CreateCheckBox(name,parent,index)
	local check = CreateFrame("CheckButton",name,parent,"OptionsBaseCheckButtonTemplate")
	check:SetPoint("LEFT");
	check:SetScript("OnClick", Checkbox_OnClick);
	check:SetScript("OnEnter",Checkbox_OnEnter) 
	check:SetScript("OnLeave", Checkbox_OnLeave);
	if SuperGuildInviteOptions["CheckBox: "..name] then
		check:SetChecked(true)
	end
	local font = check:CreateFontString("CheckFont"..index,"OVERLAY","GameFontNormal")
	font:SetText("checkbox text")
	font:SetPoint("LEFT",check,"RIGHT",5,1)
	return check,font
end


--****************************************--
--** Function to configure the Checkbox **--
--****************************************--
local function Modify_CheckButton(button,font,text,color,anchor)
	if not button then return end
	if text then
		if font then
			font:SetText(text)
		end
	end
	if type(color) == "table" then
		local font = button:GetFontString()
		font:SetTextColor(color.Red,color.Green,color.Blue)
	end
	if type(anchor) == "table" then
		button:SetPoint(anchor.Point,anchor.RelativeFrame,anchor.RelativePoint,anchor.xOfs,anchor.yOfs)
	end
end


local function CreateTimerWorld()
	local backdrop = 
	{
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background", 
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", 
		tile = true,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}
	
	local Timer = CreateFrame("Button","Timer",OptionsFrame)
	Timer:SetHeight(40)
	Timer:SetWidth(240)
	SetSavedFramePos(Timer)
	Timer:SetMovable()
	Timer:RegisterForDrag("LeftButton","RightButton")
	Timer:SetScript("OnMouseDown",function(self)
		self:StartMoving()
	end)
	Timer:SetScript("OnMouseUp",function(self)
		self:StopMovingOrSizing()
		SaveCurFramePos(self)
	end)
	Timer:SetBackdrop(backdrop)
	
	local Purge = CreateFrame("Button","Purge",Timer)
	Purge:SetBackdrop(backdrop)
	Purge:SetWidth(120)
	Purge:SetHeight(40)
	Purge:SetPoint("BOTTOM",Timer,"TOP",-55,0)
	local FPurge = Purge:CreateFontString("FPurge","OVERLAY","GameFontNormal")
	FPurge:SetText("Purge Queue")
	FPurge:SetPoint("CENTER")
	FPurge:SetTextColor(1,0,0)
	Purge:SetScript("OnClick",function()
		InviteQueue = {}
		DetailedQueue = {}
		ListNamesToInvite()
		if Frames["OptBtn10"] then
			Frames["OptBtn10"]:SetText(SGI_INVITE..": "..(#InviteQueue or ""))
		end
	end)
	
	local TimerFont = Timer:CreateFontString(nil,"OVERLAY","GameFontNormal")
	TimerFont:SetText("hh:mm:ss")
	TimerFont:SetPoint("CENTER")
	--Timer:SetScript("OnUpdate",UpdateTime)
	Frames["TimerFont"] = TimerFont
	Frames["Timer"] = Timer
end

local function UpdateTime()
	if GetTime() - TimerTime >= 1 then
		local Time
		if TimeLeft <= 0 then
			Time = SGI_TIMER_DEFAULT.."00:00:00"
		else
			local sec = TimeLeft
			local hour = floor(sec/3600)
			local mins = floor((sec-3600*hour)/60)
			local secs = sec-3600*hour-60*mins
			if hour < 10 then hour = "0"..hour end
			if mins < 10 then mins = "0"..mins end
			if secs < 10 then secs = "0"..secs end
			local text
			if cooldown then
				text = SGI_TIMER_DEFAULT
				if TimeLeft <= 1 then
					cooldown = false
				end
			else
				text = SGI_TIMER_REMAINING
			end
			Time = text..hour..":"..mins..":"..secs
		end
		Frames["TimerFont"]:SetText(Time)
		TimeLeft = TimeLeft - 1
		TimerTime = GetTime()
		
		
	elseif GetTime() - progressBar >= 0.4 then
		if Progress and cooldown and SessionTotal ~= 0 then
			Frames["OptBtn9"]:SetText("100%")
			Progress:SetWidth(208)
		elseif Progress and cooldown then
			Frames["OptBtn9"]:SetText("0%")
			Progress:SetWidth(1)
		elseif Progress then
			local CurrentTime = (#AllZones+1) * WhoDelay - TimeLeft
			local TotalTime = (#AllZones+1) * WhoDelay
			Progress:SetWidth(floor(208*(CurrentTime/TotalTime)))
			Frames["OptBtn9"]:SetText(floor(100*(CurrentTime/TotalTime)).."%")
		end
		progressBar = GetTime()
	end	
end


local function OnOptionClick(self)
	local name = self:GetName()
	
	if SuperGuildInviteOptions[name] then
		SuperGuildInviteOptions[name] = false
		Frames[name]:SetTextColor(1,0,0)
		if name == "OptBtn5" then
			SuperGuildInviteGeneral.DoInvites = false
		elseif name == "OptBtn1" then
			print(Logo..SGI_TURNED_OFF)
		elseif name == "OptBtn2" then
			print(Logo..SGI_WHISPER_BEFORE_INIVTE_OFF)
		elseif name == "OptBtn3" then
			print(Logo..SGI_AUTO_CLOSE_WHO_OFF)
		elseif name == "OptBtn8" then
			print(Logo..SGI_INVITE_FROM_WHISPER_OFF)
		elseif name == "OptBtn9" then
			print(Logo..SGI_SUPERSCAN_OFF)
			if Frames["Timer"] then Frames["Timer"]:Hide() end
		end
	else
		SuperGuildInviteOptions[name] = true
		Frames[name]:SetTextColor(0,1,0)
		if name == "OptBtn5" then
			SuperGuildInviteGeneral.DoInvites = true
		elseif name == "OptBtn1" then
			print(Logo..SGI_TURNED_ON)
		elseif name == "OptBtn2" then
			print(Logo..SGI_WHISPER_BEFORE_INIVTE_ON)
		elseif name == "OptBtn3" then
			print(Logo..SGI_AUTO_CLOSE_WHO_ON)
		elseif name == "OptBtn8" then
			print(Logo..SGI_INVITE_FROM_WHISPER_ON)
		elseif name == "OptBtn9" then
			print(Logo..SGI_SUPERSCAN_ON)
			if not Frames["Timer"] then
				CreateTimerWorld()
				Frames["Timer"]:Show()
			else
				Frames["Timer"]:Show()
			end
			Frames["Timer"]:SetScript("OnUpdate",UpdateTime)
			if GetTime()-WhoTime < 7 then
				print(Logo..SGI_SUPERSCAN_START_IN..floor((WhoTime + 7 - GetTime())).."s|r")
				TimeLeft = floor((WhoTime + 7 - GetTime()))
			end
		end
	end
end

local function ResizeOptionAndSuperScan()
	if SuperGuildInviteOptions["OptBtn9"] then
		print(Logo..SGI_SUPERSCAN_OFF)
		Frames["OptBtn9"]:SetText("SuperScan")
		if Frames["Timer"] then Frames["Timer"]:Hide() end
		
		if SuperGuildInviteOptions.OptionsFrame then
			SuperGuildInviteOptions.OptionsFrame:Show()		-- Probably need to change this
			--for i = 1,8 do
			--	Frames["OptionButton"..i]:Show()
			--end
		end
		Frames["OptionButton9"]:SetParent(SuperGuildInviteOptions.OptionsFrame)
		Frames["OptionButton10"]:SetParent(SuperGuildInviteOptions.OptionsFrame)
		Frames["OptionButton11"]:SetParent(SuperGuildInviteOptions.OptionsFrame)
		Frames["OptBtn9"]:SetTextColor(1,0,0)
		Frames["OptionButton9"]:ClearAllPoints()
		Frames["OptionButton10"]:ClearAllPoints()
		Frames["OptionButton11"]:ClearAllPoints()
		Frames["OptionButton9"]:SetPoint("TOP",SuperGuildInviteOptions.OptionsFrame,"TOP",120,-270)
		Frames["OptionButton10"]:SetPoint("TOP",SuperGuildInviteOptions.OptionsFrame,"TOP",-120,-325)
		Frames["OptionButton11"]:SetPoint("TOP",SuperGuildInviteOptions.OptionsFrame,"TOP",-120,-270)
		
		SuperGuildInviteOptions["OptBtn9"] = nil
		
		Frames["OptionButton9"]:SetScript("OnEnter",nil)
		Frames["OptionButton9"]:SetScript("OnLeave",nil)
		
	else
		print(Logo..SGI_SUPERSCAN_ON)
		if not Frames["Timer"] then
			CreateTimerWorld()
			Frames["Timer"]:Show()
		else
			Frames["Timer"]:Show()
		end
		Frames["Timer"]:SetScript("OnUpdate",UpdateTime)
		if GetTime()-WhoTime < 7 then
			print(Logo..SGI_SUPERSCAN_START_IN..floor((WhoTime + 7 - GetTime())).."s|r")
			TimeLeft = floor((WhoTime + 7 - GetTime()))
		end
		Frames["OptBtn9"]:SetTextColor(0,1,0)
		Frames["OptionButton9"]:ClearAllPoints()
		Frames["OptionButton10"]:ClearAllPoints()
		Frames["OptionButton11"]:ClearAllPoints()
		Frames["OptionButton9"]:SetParent(Timer)
		Frames["OptionButton10"]:SetParent(Timer)
		Frames["OptionButton11"]:SetParent(Timer)
		Frames["OptionButton9"]:SetPoint("TOP",Timer,"BOTTOM",0,0)
		Frames["OptionButton10"]:SetPoint("BOTTOM",Timer,"TOP",65,0)
		Frames["OptionButton11"]:SetPoint("TOP",Timer,"BOTTOM",0,-40)
		
		if SuperGuildInviteOptions.OptionsFrame then
			SuperGuildInviteOptions.OptionsFrame:Hide()		-- Probably need to change this
			--for i = 1,8 do
			--	Frames["OptionButton"..i]:Hide()
			--end
		end
		
		if not SuperScanToolTip then 
			CreateFrame("Frame","SuperScanToolTip",Timer,"GameTooltipTemplate") 
			--SuperScanToolTip:AddLine("Click here to Start or Stop SuperScan")
			SuperScanToolTip:SetPoint("TOP",Timer,"BOTTOM",0,-40)
			SuperScanToolTip:SetHeight(40)
			SuperScanToolTip:SetWidth(125)
			SuperScanToolTip:CreateFontString("SuperScanToolTipText","OVERLAY","GameFontNormal")
			SuperScanToolTipText:SetPoint("TOPLEFT",SuperScanToolTip,"TOPLEFT",8,-6)
			SuperScanToolTipText:SetText("Click here to Stop the SuperScan")
			SuperScanToolTipText:SetJustifyH("LEFT")
			SuperScanToolTipText:SetWidth(115)
		end
		Frames["OptionButton9"]:SetScript("OnEnter",function()
			SuperScanToolTip:Show()
		end)
		Frames["OptionButton9"]:SetScript("OnLeave",function()
			SuperScanToolTip:Hide()
		end)
		
		
		SuperGuildInviteOptions["OptBtn9"] = true
	end
end


local function ToggleLockout(self)
	local name = self:GetName()
	
	if SuperGuildInviteOptions[name] == 3 then
		Frames["OptBtn4"]:SetTextColor(0.2,0.7,0.5)
		Frames["OptBtn4"]:SetText(SGI_REINVITE_LOCKOUT_24)
		SuperGuildInviteOptions[name] = 1
	elseif SuperGuildInviteOptions[name] == 1 then
		Frames["OptBtn4"]:SetTextColor(0.5,1,1)
		Frames["OptBtn4"]:SetText(SGI_REINVITE_LOCKOUT_72)
		SuperGuildInviteOptions[name] = 2
	else
		Frames["OptBtn4"]:SetText(SGI_REINVITE_LOCKOUT_WEEK)
		Frames["OptBtn4"]:SetTextColor(0.7,0.23,0.93)
		SuperGuildInviteOptions[name] = 3
	end
	print(SuperGuildInviteOptions[name])
end	


local function Format_Whisper(whisper)
	local gName = GetGuildInfo(UnitName("Player"))
	local gLevel = GetGuildLevel()
	if strfind(whisper,"NAME") and strfind(whisper,"LEVEL") then
		local name = strsub(whisper,1,strfind(whisper,"NAME")-1)..gName..strsub(whisper,strfind(whisper,"NAME")+4)
		whisper = strsub(name,1,strfind(name,"LEVEL")-1)..gLevel..strsub(name,strfind(name,"LEVEL")+5)
	elseif strfind(whisper,"NAME") then
		whisper = strsub(whisper,1,strfind(whisper,"NAME")-1)..gName..strsub(whisper,strfind(whisper,"NAME")+4)
	elseif strfind(whisper,"LEVEL") then
		whisper = strsub(whisper,1,strfind(whisper,"LEVEL")-1)..gLevel..strsub(whisper,strfind(whisper,"LEVEL")+5)
	end
		
	SuperGuildInviteOptions.Whisper = whisper
	local Whisper = Whisper_AddName(whisper,"ExampleName")
	SendChatMessage(Whisper,"WHISPER",nil,UnitName("Player"))
	return whisper
end

local function BlackList_Opt()
	if SuperGuildInviteOptions.BlackList then
		SuperGuildInviteOptions.BlackList = nil
		Frames["OptBtn7"]:SetTextColor(1,0,0)
		print(Logo..SGI_AUTO_BLACKLIST_OFF)
	else
		print(Logo..SGI_AUTO_BLACKLIST_ON)
		SuperGuildInviteOptions.BlackList = true
		if not SuperGuildInviteOptions.tries then
			print(Logo..SGI_DEFAULT_AUTO_BLACKLIST)
			print(Logo..SGI_CHANGE_BLACKLIST_TIME)
			SuperGuildInviteOptions.tries = 3
		else
			print(Logo..SGI_CURRENT_BLACKTIME1..SuperGuildInviteOptions.tries..SGI_CURRENT_BLACKTIME2)
			print(Logo..SGI_CHANGE_BLACKLIST_TIME)
		end
		Frames["OptBtn7"]:SetTextColor(0,1,0)
	end
end



local function Create_InviteListFrame()
	CreateFrame("Frame","InviteListFrame")
	local Loc_Queue,i = DetailedQueue,0
	InviteListFrame:SetWidth(300)
	InviteListFrame:SetHeight(20*CountTable(DetailedQueue)+ 40) 
	SetSavedFramePos(InviteListFrame)
	
	InviteListFrame:SetMovable()
	InviteListFrame:RegisterForDrag("LeftButton","RightButton")
	InviteListFrame:SetScript("OnMouseDown",function(self)
		self:StartMoving()
	end)
	InviteListFrame:SetScript("OnMouseUp",function(self)
		self:StopMovingOrSizing()
		SaveCurFramePos(InviteListFrame)
	end)
	
	local backdrop = 
	{
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background", 
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", 
		tile = true,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}
	InviteListFrame:SetBackdrop(backdrop)
	
	local f = InviteListFrame:CreateFontString(nil,"OVERLAY","GameFontNormal")
	f:SetPoint("TOP",InviteListFrame,"TOP",-15,-15)
	f:SetText("Click on the players you wish to invite")
	
	local close = CreateFrame("Button",nil,InviteListFrame,"UIPanelCloseButton")
	close:SetPoint("TOPRIGHT",InviteListFrame,"TOPRIGHT",-4,-4)
	
	InviteListFrame:SetScript("OnShow",ListNamesToInvite)
	InviteListFrame:SetScript("OnHide",function()
		for k,_ in pairs(InviteFrames) do
			InviteFrames[k]:Hide()
		end
	end)
	
	ListNamesToInvite()
	
	
end
		
		
local function ToggleInviteList()
	if InviteListFrame and InviteListFrame:IsShown() then
		InviteListFrame:Hide()
	elseif InviteListFrame then
		InviteListFrame:Show()
	else
		Create_InviteListFrame()
	end
end

local function Create_EditBox(name,parent)																
	local frame = CreateFrame("EditBox",name,parent)
	frame:SetWidth(475)
	frame:SetHeight(220)
	frame:SetPoint("CENTER",UIParent)
	frame:SetFontObject("GameFontNormal")
	frame:SetTextInsets(20, 20, 55, -20)
	frame:SetMaxLetters(256)
	frame:SetMovable()
	frame:SetScript("OnShow",function(self)
		self:SetText(SuperGuildInviteOptions.Whisper or "")
	end)
	frame:SetScript("OnMouseDown",function(self)
		self:StartMoving()
	end)
	frame:SetScript("OnMouseUp",function(self)
		self:StopMovingOrSizing()
	end)
	local backdrop = 
	{
		bgFile = "Interface/ACHIEVEMENTFRAME/UI-Achievement-Parchment-Horizontal", 
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
		tile = false,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}
	frame:SetBackdrop(backdrop)
	
	local font = frame:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
	font:SetText(SGI_CUSTOM_WHISPER_INSTRUCTION)
	font:SetPoint("CENTER",frame,"CENTER",0,30)
	frame:SetScript("OnEnterPressed", function(self)
		local search = self:GetText()
		local Whisp = Format_Whisper(search)
		self:Hide()
	end)
	frame:SetScript("OnHide",function(self)
		self:SetText("")
	end)
	local Box = CreateFrame("Frame",nil,frame)
	Box:SetWidth(455)
	Box:SetHeight(40)
	Box:SetPoint("CENTER",frame,"CENTER",0,-40)
	local backdrop2 = 
	{
		bgFile = nil, 
		edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
		tile = false,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}
	Box:SetBackdrop(backdrop2)
	
	
	Frames.btn = CreateButton(name.."Btn",frame)
	Anchor =
		{
			Point = "BOTTOM",
			RelativeFrame = frame,
			RelativePoint = "BOTTOM",
			xOfs = 0,
			yOfs = 10
		}
	Modify_Button(Frames.btn,"Okay",40,120,nil,Anchor,function(self)
		local search = self:GetParent():GetText()
		local Whisp = Format_Whisper(search)
		self:GetParent():Hide()
	end)
	local close = CreateFrame("Button",nil,frame,"UIPanelCloseButton")
	close:SetPoint("TOPRIGHT",frame,"TOPRIGHT",-4,-4)
	frame:Hide()

	return frame
end

local function Show_Search()
	if not SuperGuildInviteOptions.Search then 
		SuperGuildInviteOptions.Search = Create_EditBox("EditBox",UIParent)
		SuperGuildInviteOptions.Search:Show()
	else
		SuperGuildInviteOptions.Search:Show()
	end
end

local function Hide_Search()
	if SuperGuildInviteOptions.Search then SuperGuildInviteOptions.Search:Hide() end
end


	

local function Create_Options()
	local OptionsFrame = CreateFrame("Frame","SuperGuildInvite")
	OptionsFrame:SetHeight(415)
	OptionsFrame:SetWidth(500)
	SetSavedFramePos(OptionsFrame)
	
	OptionsFrame:SetMovable()
	OptionsFrame:RegisterForDrag("LeftButton","RightButton")
	OptionsFrame:SetScript("OnMouseDown",function(self)
		self:StartMoving()
	end)
	OptionsFrame:SetScript("OnMouseUp",function(self)
		self:StopMovingOrSizing()
		SaveCurFramePos(OptionsFrame)
	end)
	
	local backdrop = 
	{
		bgFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Background", 
		edgeFile = "Interface\\DialogFrame\\UI-DialogBox-Gold-Border", 
		tile = true,
		tileSize = 16,
		edgeSize = 16,
		insets = { left = 4, right = 4, top = 4, bottom = 4 }
	}
	OptionsFrame:SetBackdrop(backdrop)
	
	local TitleFont = OptionsFrame:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
	TitleFont:SetText("SuperGuildInvite "..version..version_min..SGI_OPTIONS)
	TitleFont:SetPoint("TOP",OptionsFrame,"TOP",0,-20)
	
	local BottomFont = OptionsFrame:CreateFontString(nil,"OVERLAY","GameFontNormalLarge")
	BottomFont:SetText(SGI_WRITTEN_BY.."Janniie - Stormreaver EU")
	BottomFont:SetPoint("BOTTOM",OptionsFrame,"BOTTOM",0,20)
	OptionsFrame:Hide()
	SuperGuildInviteOptions.OptionsFrame = OptionsFrame
	
	-- Option button 1 --
	
	local OptBtn1 = CreateFrame("Button","OptBtn1",OptionsFrame)
	OptBtn1:SetHeight(40)
	OptBtn1:SetWidth(220)
	OptBtn1:SetPoint("TOP",OptionsFrame,"TOP",-120,-50)
	OptBtn1:SetBackdrop(backdrop)
	
	local OptFont1 = OptBtn1:CreateFontString(nil,"OVERLAY","GameFontNormal")
	OptFont1:SetText(SGI_ENABLE.." SuperGuildInvite")
	OptFont1:SetPoint("CENTER")
	if SuperGuildInviteOptions["OptBtn1"] then
		OptFont1:SetTextColor(0,1,0)
	else
		OptFont1:SetTextColor(1,0,0)
	end
	Frames["OptionButton1"] = OptBtn1
	Frames["OptBtn1"] = OptFont1
	OptBtn1:SetScript("OnClick",OnOptionClick)
	
	
	-- Option button 2 --
	local OptBtn2 = CreateFrame("Button","OptBtn2",OptionsFrame)
	OptBtn2:SetHeight(40)
	OptBtn2:SetWidth(220)
	OptBtn2:SetPoint("TOP",OptionsFrame,"TOP",120,-50)
	OptBtn2:SetBackdrop(backdrop)
	
	local OptFont2 = OptBtn2:CreateFontString(nil,"OVERLAY","GameFontNormal")
	OptFont2:SetText(SGI_SEND_A_WHISPER)
	OptFont2:SetPoint("CENTER")
	if SuperGuildInviteOptions["OptBtn2"] then
		OptFont2:SetTextColor(0,1,0)
	else
		OptFont2:SetTextColor(1,0,0)
	end
	Frames["OptionButton2"] = OptBtn2
	Frames["OptBtn2"] = OptFont2
	OptBtn2:SetScript("OnClick",OnOptionClick)
	
	-- Option button 3 --
	local OptBtn3 = CreateFrame("Button","OptBtn3",OptionsFrame)
	OptBtn3:SetHeight(40)
	OptBtn3:SetWidth(220)
	OptBtn3:SetPoint("TOP",OptionsFrame,"TOP",-120,-105)
	OptBtn3:SetBackdrop(backdrop)
	
	local OptFont3 = OptBtn3:CreateFontString(nil,"OVERLAY","GameFontNormal")
	OptFont3:SetText(SGI_AUTO_CLOSE_WHO)
	OptFont3:SetPoint("CENTER")
	if SuperGuildInviteOptions["OptBtn3"] then
		OptFont3:SetTextColor(0,1,0)
	else
		OptFont3:SetTextColor(1,0,0)
	end
	Frames["OptionButton3"] = OptBtn3
	Frames["OptBtn3"] = OptFont3
	OptBtn3:SetScript("OnClick",OnOptionClick)
	
	-- Option button 4 --
	local OptBtn4 = CreateFrame("Button","OptBtn4",OptionsFrame)
	OptBtn4:SetHeight(40)
	OptBtn4:SetWidth(220)
	OptBtn4:SetPoint("TOP",OptionsFrame,"TOP",120,-105)
	OptBtn4:SetBackdrop(backdrop)
	
	local OptFont4 = OptBtn4:CreateFontString(nil,"OVERLAY","GameFontNormal")
	OptFont4:SetPoint("CENTER")
	if SuperGuildInviteOptions["OptBtn4"] == 1 then
		OptFont4:SetTextColor(0.2,0.7,0.5)
		OptFont4:SetText(SGI_REINVITE_LOCKOUT_24)
	elseif SuperGuildInviteOptions["OptBtn4"] == 2 then
		OptFont4:SetTextColor(0.5,1,1)
		OptFont4:SetText(SGI_REINVITE_LOCKOUT_72)
	else
		OptFont4:SetText(SGI_REINVITE_LOCKOUT_WEEK)
		OptFont4:SetTextColor(0.7,0.23,0.93)
	end
	Frames["OptionButton4"] = OptBtn4
	Frames["OptBtn4"] = OptFont4
	OptBtn4:SetScript("OnClick",ToggleLockout)
	
	
	
	-- Option button 5 --
	local OptBtn5 = CreateFrame("Button","OptBtn5",OptionsFrame)
	OptBtn5:SetHeight(40)
	OptBtn5:SetWidth(220)
	OptBtn5:SetPoint("TOP",OptionsFrame,"TOP",-120,-160)
	OptBtn5:SetBackdrop(backdrop)
	
	local OptFont5 = OptBtn5:CreateFontString(nil,"OVERLAY","GameFontNormal")
	OptFont5:SetText(SGI_MANUAL_SEARCH)
	OptFont5:SetPoint("CENTER")
	if SuperGuildInviteOptions["OptBtn5"] then
		OptFont5:SetTextColor(0,1,0)
	else
		OptFont5:SetTextColor(1,0,0)
	end
	Frames["OptionButton5"] = OptBtn5
	Frames["OptBtn5"] = OptFont5
	OptBtn5:SetScript("OnClick",OnOptionClick)
	
	-- Close button --
	
	local close = CreateFrame("Button",nil,OptionsFrame,"UIPanelCloseButton")
	close:SetPoint("TOPRIGHT",OptionsFrame,"TOPRIGHT",-4,-4)
	
	
	-- Option button 6 --
	local OptBtn6 = CreateFrame("Button","OptBtn6",OptionsFrame)
	OptBtn6:SetHeight(40)
	OptBtn6:SetWidth(220)
	OptBtn6:SetPoint("TOP",OptionsFrame,"TOP",120,-160)
	OptBtn6:SetBackdrop(backdrop)
	
	local OptFont6 = OptBtn6:CreateFontString(nil,"OVERLAY","GameFontNormal")
	OptFont6:SetText(SGI_CUSTOMIZE_WHISPER)
	OptFont6:SetPoint("CENTER")
	OptFont6:SetTextColor(1,1,0)
	
	Frames["OptionButton6"] = OptBtn6
	OptBtn6:SetScript("OnClick",Show_Search)
	
	
	-- Options button 7 --
	local OptBtn7 = CreateFrame("Button","OptBtn7",OptionsFrame)
	OptBtn7:SetHeight(40)
	OptBtn7:SetWidth(220)
	OptBtn7:SetPoint("TOP",OptionsFrame,"TOP",-120,-215)
	OptBtn7:SetBackdrop(backdrop)
	
	local OptFont7 = OptBtn7:CreateFontString(nil,"OVERLAY","GameFontNormal")
	OptFont7:SetText(SGI_AUTO_BLACKLIST)
	OptFont7:SetPoint("CENTER")
	if SuperGuildInviteOptions.BlackList then
		OptFont7:SetTextColor(0,1,0)
	else
		OptFont7:SetTextColor(1,0,0)
	end
	
	Frames["OptionButton7"] = OptBtn7
	Frames["OptBtn7"] = OptFont7
	OptBtn7:SetScript("OnClick",BlackList_Opt)
	
	-- Options button 8 --
	local OptBtn8 = CreateFrame("Button","OptBtn8",OptionsFrame)
	OptBtn8:SetHeight(40)
	OptBtn8:SetWidth(220)
	OptBtn8:SetPoint("TOP",OptionsFrame,"TOP",120,-215)
	OptBtn8:SetBackdrop(backdrop)
	
	local OptFont8 = OptBtn8:CreateFontString(nil,"OVERLAY","GameFontNormal")
	OptFont8:SetText(SGI_WHISPER_AUTO_INV)
	OptFont8:SetPoint("CENTER")
	if SuperGuildInviteOptions.BlackList then
		OptFont8:SetTextColor(0,1,0)
	else
		OptFont8:SetTextColor(1,0,0)
	end
	Frames["OptionButton8"] = OptBtn8
	Frames["OptBtn8"] = OptFont8
	OptBtn8:SetScript("OnClick",OnOptionClick)
	
	-- Options Button 9 --
	local OptBtn9 = CreateFrame("Button","OptBtn9",OptionsFrame)
	OptBtn9:SetHeight(40)
	OptBtn9:SetWidth(220)
	OptBtn9:SetPoint("TOP",OptionsFrame,"TOP",120,-270)
	OptBtn9:SetBackdrop(backdrop)
	local Progress = OptBtn9:CreateTexture("Progress")
	Progress:SetPoint("LEFT",OptBtn9,"LEFT",6,0)
	Progress:SetWidth(1)
	Progress:SetHeight(28)
	Progress:SetTexture(1,0.5,0,0.4)
	
	local OptFont9 = OptBtn9:CreateFontString(nil,"OVERLAY","GameFontNormal")
	OptFont9:SetText("SuperScan")
	OptFont9:SetPoint("CENTER")
	if SuperGuildInviteOptions["OptBtn9"] then
		OptFont9:SetTextColor(0,1,0)
	else
		OptFont9:SetTextColor(1,0,0)
	end
	
	Frames["OptionButton9"] = OptBtn9
	Frames["OptBtn9"] = OptFont9
	OptBtn9:SetScript("OnClick",ResizeOptionAndSuperScan)
	
	
	-- Options Button 10 --
	local OptBtn10 = CreateFrame("Button","OptBtn10",OptionsFrame)
	OptBtn10:SetHeight(40)
	OptBtn10:SetWidth(110)
	OptBtn10:SetPoint("TOP",OptionsFrame,"TOP",0-120,-325)
	OptBtn10:SetBackdrop(backdrop)
	
	local OptFont10 = OptBtn10:CreateFontString(nil,"OVERLAY","GameFontNormal")
	OptFont10:SetText(SGI_INVITE..": "..(#InviteQueue or ""))
	OptFont10:SetPoint("CENTER")

	OptFont10:SetTextColor(0,1,1)

	Frames["OptionButton10"] = OptBtn10
	Frames["OptBtn10"] = OptFont10
	OptBtn10:SetScript("OnClick",Manual_Invite)
	
	-- Options Button 11 --
	local OptBtn10 = CreateFrame("Button","OptBtn11",OptionsFrame)
	OptBtn11:SetHeight(40)
	OptBtn11:SetWidth(220)
	OptBtn11:SetPoint("TOP",OptionsFrame,"TOP",0-120,-270)
	OptBtn11:SetBackdrop(backdrop)
	
	local OptFont11 = OptBtn11:CreateFontString(nil,"OVERLAY","GameFontNormal")
	OptFont11:SetText("Choose Invites")
	OptFont11:SetPoint("CENTER")

	OptFont11:SetTextColor(1,1,0)

	Frames["OptionButton11"] = OptBtn11
	Frames["OptBtn11"] = OptFont11
	OptBtn11:SetScript("OnClick",ToggleInviteList)
	
	
	
	
end

Funcs["Options"] = Create_Options


local function Show_Options()
	if not SuperGuildInviteOptions.OptionsFrame then 
		Create_Options() 
		SuperGuildInviteOptions.OptionsFrame:Show()
	else
		SuperGuildInviteOptions.OptionsFrame:Show()
	end
end

local function Hide_Options()
	if SuperGuildInviteOptions.OptionsFrame then SuperGuildInviteOptions.OptionsFrame:Hide() end
end

local function Toggle_Options()
	if SuperGuildInviteOptions.OptionsFrame and SuperGuildInviteOptions.OptionsFrame:IsShown() then
		Hide_Options()
	else
		Show_Options()
	end
end
	
	
local function Create_MiniMapButton()
	local f = CreateFrame("Button","SGIMiniMapButton",Minimap)
	f:SetWidth(32)
	f:SetHeight(32)
	f:SetFrameStrata("MEDIUM")
	f:SetMovable(true)
	f:SetUserPlaced(true)
	f:SetNormalTexture("Interface\\AddOns\\SuperGuildInvite\\SGI_MiniMapButton")
	f:SetPushedTexture("Interface\\AddOns\\SuperGuildInvite\\SGI_MiniMapButtonPushed")
	f:SetHighlightTexture("Interface\\Minimap\\UI-Minimap-ZoomButton-Highlight")
	
	local function moveButton(self)
		local centerX, centerY = Minimap:GetCenter()
		local x, y = GetCursorPosition()
		x, y = x / self:GetEffectiveScale() - centerX, y / self:GetEffectiveScale() - centerY
		centerX, centerY = math.abs(x), math.abs(y)
		centerX, centerY = (centerX / math.sqrt(centerX^2 + centerY^2)) * 78, (centerY / sqrt(centerX^2 + centerY^2)) * 78
		centerX = x < 0 and -centerX or centerX
		centerY = y < 0 and -centerY or centerY
		self:ClearAllPoints()
		self:SetPoint("CENTER", centerX, centerY)
		SaveCurFramePos(self)
	end
	
	f:SetScript("OnMouseDown",function(self,button)
		if button == "RightButton" then
			self:SetScript("OnUpdate",moveButton)
		end
	end)
	f:SetScript("OnMouseUp",function(self,button)
		self:SetScript("OnUpdate",nil)
	end)
	f:SetScript("OnClick",function(self,button)
		if button == "LeftButton" then
			if not SuperGuildInviteOptions.OptionsFrame then 
				Create_Options() 
				SuperGuildInviteOptions.OptionsFrame:Show()
			elseif SuperGuildInviteOptions.OptionsFrame:IsShown() then
				SuperGuildInviteOptions.OptionsFrame:Hide()
			else
				SuperGuildInviteOptions.OptionsFrame:Show()
			end
		end
	end)
	
	Frames["MiniMapButton"] = f
end



local function Show_MiniMapButton()
	if Frames["MiniMapButton"] then
		Frames["MiniMapButton"]:Show()
	else
		Create_MiniMapButton()
		Frames["MiniMapButton"]:Show()
	end
end
	
Funcs["MiniMapButton"] = Show_MiniMapButton
Funcs["MiniMapButton"]()
	
	


local function ShowTimer()
	if not Frames["Timer"] then
		CreateTimerWorld()
		Frames["Timer"]:Show()
	else
		Frames["Timer"]:Show()
	end
end

local function HideTimer()
	if Frames["Timer"] then Frames["Timer"]:Hide() end
end
		
	
	
local function SlashCommandHndl(msg)
	if msg == 'toggle' then
		if SuperGuildInviteOptions["OptBtn1"] then
			SuperGuildInviteOptions["OptBtn1"] = false
			ChatFrame1:AddMessage(Logo..SGI_TURNED_OFF,1,0,0,1)
		else
			SuperGuildInviteOptions["OptBtn1"] = true
			ChatFrame1:AddMessage(Logo..SGI_TURNED_ON,0,1,0,1)
		end
	elseif msg == 'config' then
		Show_Options()
	elseif msg == 'test' then
		ToggleInviteList()
	elseif msg == 'hide' then
		Hide_Options()
	elseif msg == 'on' then
		SuperGuildInviteOptions["OptBtn1"] = true
		ChatFrame1:AddMessage(Logo..SGI_TURNED_ON,0,1,0,1)
	elseif msg == 'off' then
		SuperGuildInviteOptions["OptBtn1"] = false
		ChatFrame1:AddMessage(Logo..SGI_TURNED_OFF,1,0,0,1)
	elseif msg == 'timer' then
		ShowTimer()
	elseif msg == 'timeroff' then
		HideTimer()
	elseif msg == 'reset' then
		SuperGuildInviteOptions = nil
		SuperGuildInviteGeneral = nil
		BlackList = nil
		LoginPlayer()
		ChatFrame1:AddMessage(Logo..SGI_RESET,1,0.2,0.2,1)
	elseif msg == 'purge' then
		InviteQueue = {}
		DetailedQueue = {}
		ListNamesToInvite()
		print(Logo..SGI_INVITE_QUEUE_PURGE)
		if Frames["OptBtn10"] then
			Frames["OptBtn10"]:SetText(SGI_INVITE..": "..(#InviteQueue or ""))
		end
	elseif msg == 'showblacklist' then
		DisplayBlacklist()
	elseif strfind(msg,"blacklist") then
		local name = strsub(msg,11)
		Add_To_Blacklist(name,"MANUAL")
	elseif strfind(msg,"blacktime") then
		local tries = tonumber(strsub(msg,11))
		SuperGuildInviteOptions.tries = tries
		print(Logo..SGI_BLACKTIME_CHANGED..SuperGuildInviteOptions.tries..SGI_CURRENT_BLACKTIME2)
	elseif strfind(msg,"limit") then
		local top,bot
		if strfind(msg,"-") then
			bot = tonumber(strsub(msg,7,strfind(msg,"-")-1))
			top = tonumber(strsub(msg,strfind(msg,"-")+1))
			Create_Search(bot,top)
			SuperGuildInviteOptions.LowLimit = bot
			SuperGuildInviteOptions.HighLimit = top
		else
			bot = tonumber(strsub(msg,7))
			Create_Search(bot)
			SuperGuildInviteOptions.LowLimit = bot
			top = 85
		end
		print(Logo..SGI_LIMIT_CHANGED.."|cffcccccc"..bot.." - "..top.."|r")
	elseif msg == '' or msg == 'help' then
		print(Logo.."|cff88ffffVersion "..version)
		print(Logo.."|cff88ffffSlashCommands:")
		print(Logo.."|cff88ffff/sgi toggle,"..SGI_SLASH_COMMANDS[1])
		print(Logo.."|cff88ffff/sgi on,"..SGI_SLASH_COMMANDS[2])
		print(Logo.."|cff88ffff/sgi off,"..SGI_SLASH_COMMANDS[3])
		print(Logo.."|cff88ffff/sgi config,"..SGI_SLASH_COMMANDS[4])
		print(Logo.."|cff88ffff/sgi limit #,"..SGI_SLASH_COMMANDS[5])
		print(Logo.."|cff88ffff/sgi showblacklist,"..SGI_SLASH_COMMANDS[6])
		print(Logo.."|cff88ffff/sgi purge,"..SGI_SLASH_COMMANDS[7])
		print(Logo.."|cff88ffff/sgi blacklist name,"..SGI_SLASH_COMMANDS[8])
		print(Logo.."|cff88ffff/sgi blacktime #,"..SGI_SLASH_COMMANDS[9])
		print(Logo.."|cff88ffff/sgi reset,"..SGI_SLASH_COMMANDS[10])
	end
end



Funcs.OnRegisteredEvent = OnRegisteredEvent
Funcs.SlashCommandHndl = SlashCommandHndl

